<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-app>
    <v-navigation-drawer v-model="drawer" v-if="this.session" app clipped>
      <v-card elevation="1" tile>
        <v-list-item>
          <v-list-item-avatar>
            <v-icon style="display: none">mdi-account-circle</v-icon>
            <img
              :src="util.CONFIG.API_BASE_URL + `/v1/users/${this.session.user.id}/image`"
              onerror="this.style.display='none';this.parentElement.children[0].style.display='initial';"
              onload="this.style.display='initial';this.parentElement.children[0].style.display='none';"
            />
          </v-list-item-avatar>
          <v-list-item-content>
            <v-list-item-title class="subtitle-1"
              >{{ this.session.user.firstname }} {{ this.session.user.surname }}
            </v-list-item-title>
            <v-list-item-subtitle class="caption"
              >{{ this.session.user.displayName }}
            </v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
        <v-card-text class="caption pa-0 px-2 pb-1 text-center"
          >{{ this.session.user.mail }}
        </v-card-text>
      </v-card>
      <v-list dense class="pa-0 ma-0">
        <v-list-item link to="/dashboard">
          <v-list-item-action>
            <v-icon color="grey darken-1">mdi-view-dashboard</v-icon>
          </v-list-item-action>
          <v-list-item-title class="grey--text text--darken-1">Dashboard</v-list-item-title>
        </v-list-item>
        <v-list-item link to="/me">
          <v-list-item-action>
            <v-icon color="grey darken-1">mdi-badge-account-horizontal</v-icon>
          </v-list-item-action>
          <v-list-item-title class="grey--text text--darken-1">Mein Profil</v-list-item-title>
        </v-list-item>
        <v-list-item
          link
          to="/membership"
          v-if="this.config.bindings.multiservice.plugin.supportMembershipDB"
        >
          <v-list-item-action>
            <v-icon color="grey darken-1">mdi-account-key</v-icon>
          </v-list-item-action>
          <v-list-item-title class="grey--text text--darken-1"
            >Fördermitgliedschaft</v-list-item-title
          >
        </v-list-item>
        <v-list-item link to="/gdpr">
          <v-list-item-action>
            <v-icon color="grey darken-1">mdi-shield-check</v-icon>
          </v-list-item-action>
          <v-list-item-title class="grey--text text--darken-1"
            >Datenschutzbestimmungen</v-list-item-title
          >
        </v-list-item>
        <v-list-item link to="/deleteuser" v-if="this.session.miniSession">
          <v-list-item-action>
            <v-icon color="grey darken-1">mdi-account-remove</v-icon>
          </v-list-item-action>
          <v-list-item-title class="grey--text text--darken-1">Löschen</v-list-item-title>
        </v-list-item>
        <v-list-group
          prepend-icon="mdi-account-outline"
          value="true"
          v-if="this.session.miniSession !== true"
        >
          <template v-slot:activator>
            <v-list-item-title>Benutzer</v-list-item-title>
          </template>
          <v-list-item link to="/users">
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1">Benutzerliste</v-list-item-title>
          </v-list-item>
          <v-list-item
            link
            to="/invitations"
            v-if="
              this.session.user.permissions.includes('INVITE') ||
              this.session.user.permissions.includes('ADMIN')
            "
          >
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account-star</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1">Einladungen</v-list-item-title>
          </v-list-item>
          <v-list-item
            link
            to="/processtrials"
            v-if="
              (this.session.user.permissions.includes('INVITE') ||
                this.session.user.permissions.includes('ADMIN')) &&
              this.config.bindings.multiservice.plugin.supportMembershipDB
            "
          >
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account-alert</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1"
              >Erhöhte Rechte Verwalten</v-list-item-title
            >
          </v-list-item>
          <v-list-item link to="/adduser" v-if="this.session.user.permissions.includes('ADMIN')">
            <v-list-item-action>
              <v-icon color="red darken-1">mdi-account-plus</v-icon>
            </v-list-item-action>
            <v-list-item-title class="red--text text--darken-1">Neue Anlegen</v-list-item-title>
          </v-list-item>
          <v-list-item link to="/deleteuser">
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account-remove</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1">Löschen</v-list-item-title>
          </v-list-item>
        </v-list-group>
        <v-list-group
          prepend-icon="mdi-account-multiple-outline"
          v-if="this.session.miniSession !== true"
        >
          <template v-slot:activator>
            <v-list-item-title>Gruppen</v-list-item-title>
          </template>
          <v-list-item link to="/groups">
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account-multiple</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1">Gruppenliste</v-list-item-title>
          </v-list-item>
          <v-list-item link to="/addgroup" v-if="session.user.permissions.includes('ADMIN')">
            <v-list-item-action>
              <v-icon color="red darken-1">mdi-account-multiple-plus</v-icon>
            </v-list-item-action>
            <v-list-item-title class="red--text text--darken-1">Neue Anlegen</v-list-item-title>
          </v-list-item>
          <v-list-item link to="/deletegroup" v-if="session.user.permissions.includes('ADMIN')">
            <v-list-item-action>
              <v-icon color="red darken-1">mdi-account-multiple-remove</v-icon>
            </v-list-item-action>
            <v-list-item-title class="red--text text--darken-1">Löschen</v-list-item-title>
          </v-list-item>
        </v-list-group>
        <v-list-group
          prepend-icon="mdi-auto-fix"
          v-if="
            this.session.user.permissions.includes('RESET_SANDBOX') ||
            this.session.user.permissions.includes('UPLOAD_SUPPORT_MEMBER') ||
            (this.session.user.permissions.includes('ADMIN') && this.session.miniSession !== true)
          "
        >
          <template v-slot:activator>
            <v-list-item-title>Administration</v-list-item-title>
          </template>
          <v-list-item
            link
            to="/plausibility"
            v-if="
              (this.config.bindings.openproject.enabled ||
                this.config.bindings.nextcloud.enabled) &&
              this.session.user.permissions.includes('ADMIN')
            "
          >
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-checkbox-marked</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1"
              >Nutzerplausibilität</v-list-item-title
            >
          </v-list-item>
          <v-list-item
            link
            to="/groupplausibility"
            v-if="
              (this.config.bindings.openproject.enabled ||
                this.config.bindings.nextcloud.enabled) &&
              this.session.user.permissions.includes('ADMIN')
            "
          >
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account-multiple-check</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1"
              >Gruppenplausibilität</v-list-item-title
            >
          </v-list-item>
          <v-list-item
            link
            to="/sandboxstatus"
            v-if="
              this.config.bindings.openproject &&
              this.config.bindings.openproject.enabled &&
              (this.session.user.permissions.includes('RESET_SANDBOX') ||
                this.session.user.permissions.includes('ADMIN'))
            "
          >
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-cards-playing-outline</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1">Sandbox</v-list-item-title>
          </v-list-item>
          <v-list-item link to="/gdprAdmin" v-if="this.session.user.permissions.includes('ADMIN')">
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-file-document-outline</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1"
              >Datenschutz verwalten</v-list-item-title
            >
          </v-list-item>
          <v-list-item
            link
            to="/uploadmembershipdb"
            v-if="
              this.config.bindings.multiservice.plugin.supportMembershipDB &&
              (this.session.user.permissions.includes('UPLOAD_SUPPORT_MEMBER') ||
                this.session.user.permissions.includes('ADMIN'))
            "
          >
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account-convert</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1"
              >Mitgliedschafts-DB</v-list-item-title
            >
          </v-list-item>
          <v-list-item link to="/chapters" v-if="this.session.user.permissions.includes('ADMIN')">
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-nut</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1"
              >Struktureinstellungen</v-list-item-title
            >
          </v-list-item>
          <v-list-item
            link
            to="/admin_blocked"
            v-if="this.session.user.permissions.includes('ADMIN')"
          >
            <v-list-item-action>
              <v-icon color="grey darken-1">mdi-account-cancel</v-icon>
            </v-list-item-action>
            <v-list-item-title class="grey--text text--darken-1"
              >Geblockte Benutzer:innen</v-list-item-title
            >
          </v-list-item>
        </v-list-group>
      </v-list>
    </v-navigation-drawer>

    <v-app-bar app clipped-left :color="util.CONFIG.MAIN_BAR_COLOR" dense v-if="this.session">
      <v-app-bar-nav-icon @click.stop="drawer = !drawer" />
      <v-img class="mx-2" :src="util.CONFIG.LOGO_URL" max-height="44" max-width="132" contain />
      <v-toolbar-title class="mr-12 align-center">
        <span class="title">{{ $route.name }}</span>
      </v-toolbar-title>
      <v-spacer />
      <v-btn tile to="/logout">
        <v-icon>mdi-power</v-icon>
        Logout
      </v-btn>
    </v-app-bar>

    <v-main>
      <v-container class="fill-height" fluid v-if="!this.session">
        <v-row align="center" justify="center">
          <v-col cols="12" sm="8" md="4">
            <v-card class="elevation-12 pa-6">
              <v-container>
                <v-row no-gutters :style="'background-color: ' + util.CONFIG.MAIN_BAR_COLOR">
                  <v-col class="pa-2" sm="4">
                    <v-img :src="util.CONFIG.LOGO_URL" width="150" />
                  </v-col>
                  <v-col sm="8">
                    <v-card-title>{{ util.CONFIG.VENDOR_NAME }}</v-card-title>
                    <v-card-subtitle>Benutzerverwaltung - {{ $route.name }}</v-card-subtitle>
                  </v-col>
                </v-row>
              </v-container>

              <div v-if="loading" class="text-center">
                <v-progress-circular indeterminate color="primary"></v-progress-circular>
              </div>
              <div v-else>
                <error-alert :error="error"></error-alert>
                <router-view
                  v-on:networkError="networkError()"
                  v-on:forbiddenError="forbiddenError()"
                  v-on:unexpectedError="unexpectedError()"
                ></router-view>
              </div>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
      <v-container v-else fluid>
        <div>
          <error-alert :error="error"></error-alert>
        </div>
        <v-alert type="warning" prominent v-if="this.session.miniSession">
          Sie sind mit einer beschränkten Session eingeloggt. Dies ist der Fall, da Sie noch die
          folgenden Aktionen ausführen müssen. Sie haben jederzeit die Möglichkeit Ihren Account
          vollständig zu löschen oder die Accountdaten einzusehen. Bitte führen Sie alle Schritte
          durch um wieder vollen Zugriff auf alle Funktionen zu erlangen.

          <ul>
            <li v-for="item in actions" :key="item.name">
              {{ item.description }}
            </li>
          </ul>
        </v-alert>
        <div v-if="loading" class="text-center">
          <v-progress-circular indeterminate color="primary"></v-progress-circular>
        </div>
        <router-view
          v-else
          v-on:networkError="networkError()"
          v-on:forbiddenError="forbiddenError()"
          v-on:unexpectedError="unexpectedError()"
          v-on:clearError="clearError()"
          v-on:refreshSession="refreshSession()"
        ></router-view>
      </v-container>
    </v-main>

    <v-footer app>
      <div>
        Frontend Version: {{ gitVersion }}, Backend Version
        <v-progress-circular
          v-if="loading && config == null"
          indeterminate
          size="20"
        ></v-progress-circular>
        <span v-else-if="config != null">{{ config.version }}</span>
        <span v-else>nicht ermittelbar</span>
      </div>
      <v-spacer></v-spacer>
      <div>
        &copy; 2020 by
        <a
          href="https://gitlab.com/ingenieure-ohne-grenzen/feather/-/blob/main/AUTHORS.md"
          class="deep-orange--text"
          target="_blank"
          >Feather development team</a
        >, Licensed under
        <a
          href="https://gitlab.com/ingenieure-ohne-grenzen/feather/-/blob/main/LICENSE"
          class="deep-orange--text"
          target="_blank"
          >Apache 2.0</a
        >
      </div>
    </v-footer>
  </v-app>
</template>
<script>
import Api from '../LegacyApi';
import * as util from '../util';
import { VApp } from 'vuetify/lib';
import { useApplicationStore } from '../stores/application';

export default {
  components: {
    VApp,
  },
  computed: {
    session() {
      this.refreshActions(this.applicationStore.session);
      return this.applicationStore.session;
    },
    config() {
      return this.applicationStore.config;
    },
    requestLogout() {
      return this.applicationStore.logoutRequest;
    },
  },
  methods: {
    networkError: function () {
      this.loading = false;
      this.error = 'network';
    },
    forbiddenError: function () {
      this.loading = false;
      this.error = 'forbidden';
    },
    unexpectedError: function () {
      this.loading = false;
      this.error = 'unexpected';
    },
    clearError: function () {
      if (!this.loading) {
        this.error = undefined;
      }
    },
    refreshActions: function (session) {
      if (session) {
        this.loading = true;

        Api.defaultHandler(this, Api.getMyOpenActions())
          .then()
          .then((data) => {
            if (data.length == 0 && session.miniSession) {
              Api.finalizeMyActions().then((data) => {
                if (data.startsWith('/')) {
                  Api.defaultHandler(this, Api.getSession()).then((result) => {
                    this.applicationStore.setSession(result);
                    this.loading = false;
                    this.$router.push(data);
                  });
                } else {
                  window.location.href = data;
                }
              });
            } else {
              this.actions = data;
              this.loading = false;

              if (data.length > 0) {
                const first = data[0];
                if (this.$route.fullPath != '/' + first.name) {
                  this.$router.push('/' + first.name);
                }
              }
            }
          });
      }
    },
    refreshSession: function () {
      this.refreshActions(this.session);
    },
  },
  watch: {
    requestLogout: function (val) {
      if (val) {
        this.$router.push('/logout');
      }
    },
  },
  mounted() {
    this.$on('networkError', () => {
      this.networkError();
    });
    this.$on('forbiddenError', () => {
      this.forbiddenError();
    });
    this.$on('unexpectedError', () => {
      this.unexpectedError();
    });

    let sessionCheck = Api.defaultHandler(this, Api.getSession());
    let configCheck = Api.defaultHandler(this, Api.getConfig());

    configCheck.then((result) => {
      this.applicationStore.setConfig(result);
    });

    Promise.all([sessionCheck, configCheck]).then(() => {
      sessionCheck.then((result) => {
        this.applicationStore.setSession(result);

        if (result) {
          this.refreshActions();
        } else {
          this.loading = false;
        }
      });
    });
  },
  data() {
    return {
      loading: true,
      error: undefined,
      drawer: null,
      gitVersion: import.meta.env.VUE_APP_GIT_HASH,
      actions: [],
      applicationStore: useApplicationStore(),
      util,
    };
  },
};
</script>
